package bensley.FutureRadio;

import java.io.IOException;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnPreparedListener;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.util.Log;

public class StreamService extends Service implements OnPreparedListener {
	
	// Streaming variables & objects
	public static String STR_URL;
	public static Integer INT_PLAY_STATE=0;
	public Integer INT_DURATION_MILLIS;
	public Integer INT_DURATION_SECONDS;
	public Integer INT_DURATION_MINUTES;
	
	public static Timer TMR_DURATION;
	public static Timer TMR_CONNECT;
	public static Thread THD_MPLAYER;
	// Class interfaces for the media player 
	MediaPlayer CLS_MPLAYER = new MediaPlayer();
	// These two are used for monitoring call state changes to stop the service 
	// when a call is being initiated/received
	TelephonyManager CLS_TELE_MANAGER;
	PhoneStateListener CLS_PHONE_STATELISTENER;
	
	public static boolean BOL_ONLINE = false;
	
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	public void onCreate() {
		CLS_TELE_MANAGER = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
	    // Create a new PhoneStateListener
		CLS_PHONE_STATELISTENER = new PhoneStateListener() {
	        @Override
	        public void onCallStateChanged(int state, String incomingNumber) {
	            switch (state) {
	            // Only take note of these events if the stream is currently active;
	            case TelephonyManager.CALL_STATE_OFFHOOK: // This covers outgoing calls
	            	if (CLS_MPLAYER.isPlaying() == true && CLS_MPLAYER != null) { onDestroy(); }
	                break;
	            case TelephonyManager.CALL_STATE_RINGING: // This covers incoming calls
	                if (CLS_MPLAYER.isPlaying() == true && CLS_MPLAYER != null) { onDestroy(); }
	                break;
	            }
	        }
	    };
	    // Register the listener with the telephony manager
	    CLS_TELE_MANAGER.listen(CLS_PHONE_STATELISTENER, PhoneStateListener.LISTEN_CALL_STATE);
	}
	
	public void onPrepared(MediaPlayer CLS_MPLAYER) {
		// Implemented for prepareAsync() so start() is moved to here from service.onStart()
    	CLS_MPLAYER.start();
    }

	@Override
	public void onStart(Intent intent, int startid) {
		FutureRadio.TXT_DURATION.setText("");
        INT_DURATION_MILLIS = 0;
        INT_DURATION_SECONDS = 0;
        INT_DURATION_MINUTES = 0;
        CLS_MPLAYER.setOnPreparedListener(StreamService.this);
		StreamService.THD_MPLAYER = new Thread() {
			public void run() {
	    	    try {
	    	    		CLS_MPLAYER.setDataSource(STR_URL.toString());
	    	    	} catch (IllegalArgumentException e) {
	    	    		//e.printStackTrace();
	    	    	} catch (IllegalStateException e) {
	    	    		//e.printStackTrace();
	    	    	} catch (IOException e) {
	    	    		//e.printStackTrace();
	    	    	}
	    	    try {
	    	    		//CLS_MPLAYER.prepare();
	    	    		CLS_MPLAYER.prepareAsync();
	    	    		//e.printStackTrace();
	    	    	} catch (IllegalStateException e) {
	    	    		//e.printStackTrace();
	    	    	}
			}
			
		};
		StreamService.THD_MPLAYER.start();
		
		StreamService.TMR_DURATION = new Timer();
		StreamService.TMR_DURATION.schedule(new ttDuration(), 200, 200);
		
		StreamService.TMR_CONNECT = new Timer();
		StreamService.TMR_CONNECT.schedule(new ttConnected(), 30000, 30000);
		
		if(STR_URL == getString(R.string.str32URL)){
			INT_PLAY_STATE=1;
			FutureRadio.BTN_LISTEN32.setText(R.string.strStop); // Update UI
			FutureRadio.BTN_LISTEN64.setVisibility(4);
		}else if(STR_URL == getString(R.string.str64URL)){
			INT_PLAY_STATE=2;
			FutureRadio.BTN_LISTEN64.setText(R.string.strStop); // Update UI
			FutureRadio.BTN_LISTEN32.setVisibility(4);
		}
	}

	@Override
	public void onDestroy() {
		StreamService.TMR_DURATION.cancel();
		StreamService.TMR_CONNECT.cancel();
		FutureRadio.BTN_LISTEN32.setText(R.string.strListen32); // Reset UI
		FutureRadio.BTN_LISTEN32.setVisibility(0);
		FutureRadio.BTN_LISTEN64.setText(R.string.strListen64);
		FutureRadio.BTN_LISTEN64.setVisibility(0);
		FutureRadio.TXT_DURATION.setText("");
		CLS_MPLAYER.stop();
		CLS_MPLAYER.reset();
		StreamService.THD_MPLAYER = null;
		INT_PLAY_STATE=0;
	}
    
    class ttDuration extends TimerTask
    {
            @Override
            public void run()
            {
            	hdrDuration.sendEmptyMessage(0);
            }
    }
    
    Handler hdrDuration = new Handler()
    {
    	@Override
    	public void handleMessage(Message m)
    	{
    		if(CLS_MPLAYER.isPlaying() == true)
    		{
    			INT_DURATION_MILLIS+=200;
    			if(INT_DURATION_MILLIS>=1000){
    				INT_DURATION_MILLIS=0;
    				INT_DURATION_SECONDS++;
    				if(INT_DURATION_SECONDS>=60) {
    					INT_DURATION_MINUTES++;
    					INT_DURATION_SECONDS=0;
    				}
    				if(INT_DURATION_SECONDS<10){
    					FutureRadio.TXT_DURATION.setText(Integer.toString(INT_DURATION_MINUTES)+":0"+Integer.toString(INT_DURATION_SECONDS));
    				}else{           	
    					FutureRadio.TXT_DURATION.setText(Integer.toString(INT_DURATION_MINUTES)+":"+Integer.toString(INT_DURATION_SECONDS));
    				}
    			}
    		}
    	}
    };

    
    class ttConnected extends TimerTask
    {
    	@Override
        public void run()
        {
    		hdrConnected.sendEmptyMessage(0);
    	}
    }
    
    Handler hdrConnected = new Handler()
    {
    	@Override
    	public void handleMessage (Message m)
    	{
    		if(CLS_MPLAYER.isPlaying() == false)
        	{
    			if(isOnline()==true){
    				FutureRadio.TXT_DURATION.setText("Connecting");
    				CLS_MPLAYER.reset();
    				StreamService.THD_MPLAYER = null;
    				StreamService.THD_MPLAYER = new Thread() {
    					public void run() {
    						try {
    		    	    		CLS_MPLAYER.setDataSource(STR_URL.toString());
    		    	    	} catch (IllegalArgumentException e) {
    		    	    	} catch (IllegalStateException e) {
    		    	    	} catch (IOException e) {
    		    	    	}
    		    	    	try {
    		    	    		CLS_MPLAYER.prepare();
    		    	    	} catch (IOException e) {
    		    	    	} catch (IllegalStateException e) {
    		    	    	}
    		    	    	CLS_MPLAYER.start();
    		    	    	Log.d("here: ", "trying to start()");
    					}
    				};
    				StreamService.THD_MPLAYER.start();
    			}else{ //isOnline()
    				FutureRadio.TXT_DURATION.setText("No connection available");
    			}
        	}//CLS_MPLAYER.isPlaying()
    	}
    };
    
    public boolean isOnline() { //Method to check if a network connection is detected, returns true if so;
        ConnectivityManager connectivityManager = (ConnectivityManager)getApplicationContext().getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();
        boolean connected = networkInfo != null && networkInfo.isAvailable() && networkInfo.isConnected();
        return connected;
    }

}
