package bensley.FutureRadio;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;
import java.net.URLConnection;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.AudioManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;

public class WebCam extends Activity {

	// Interface variables and objects
	Button BTN_REFRESH;
	ImageView IMG_WEBCAM;
	String STR_CAM_URL;
	Bitmap BMP_WEBCAM;

	//public Thread THD_WEBCAM;
	public ProgressDialog PD_LOADING;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.webcam);
        
        BTN_REFRESH = (Button)this.findViewById(R.id.btnRefresh);
        BTN_REFRESH.setOnClickListener(new Button.OnClickListener() {public void onClick(View v) {new imageRefresh().execute();} });
        IMG_WEBCAM = (ImageView) findViewById(R.id.imgWebCam);
        STR_CAM_URL = getString(R.string.strCamURL);
        
        // Lock the context of the volume buttons
        setVolumeControlStream(AudioManager.STREAM_MUSIC);
        
        new imageRefresh().execute(); // Initial load of the web cam image
    }
    
    private class imageRefresh extends AsyncTask<Void, Integer, Void>
    {
    
    	ProgressDialog PD_LOADING;
    	
    	protected void onPreExecute() {
    		PD_LOADING = ProgressDialog.show(WebCam.this, "Refreshing" , "Loading, please wait ... ", true, true,
    				new DialogInterface.OnCancelListener(){
                    	@Override
                    	public void onCancel(DialogInterface dialog) {
                    		imageRefresh.this.cancel(true);
                    		finish();
                    	}
                   	}
    		);
    	}
    
    	@Override
    	protected Void doInBackground(Void... params) {
    		
    		//Bitmap BMP_WEBCAM = null;
            InputStream in = null;        
            int response = -1;
            URL url = null;
            URLConnection conn = null;
            
			try {
				url = new URL(STR_CAM_URL);
			} catch (MalformedURLException e1) {
				Log.d("Web Cam: ", "Bad web cam URL given");
				e1.printStackTrace();
			}
            
            
			try {
				conn = url.openConnection();
			} catch (IOException e1) {
				Log.d("Web Cam: ", "Error opening connect to URL for web cam");
				e1.printStackTrace();
			}
                         
            //if (!(conn instanceof HttpURLConnection)) {
            //    Log.d("Not an HTTP connection", "");
            //}else{
            	HttpURLConnection httpConn = (HttpURLConnection) conn;
                httpConn.setAllowUserInteraction(false);
                httpConn.setInstanceFollowRedirects(true);
                try {
					httpConn.setRequestMethod("GET");
				} catch (ProtocolException e) {
					Log.d("Web Cam: ", "Couldn't set the HTTP get command for the web cam");
					e.printStackTrace();
				}
                try {
					httpConn.connect();
				} catch (IOException e) {
					Log.d("Web Cam: ", "Couldn't connect to the web cam HTTP resource");
					e.printStackTrace();
				} 

                try {
					response = httpConn.getResponseCode();
				} catch (IOException e) {
					Log.d("Web Cam: ", "Error getting HTTP response code");
					e.printStackTrace();
				}                 
                if (response == HttpURLConnection.HTTP_OK) {
                    try {
						in = httpConn.getInputStream();
					} catch (IOException e) {
						Log.d("Web Cam: ", "Error parsing to input stream");
						e.printStackTrace();
					}                                 
                }                     
            //}	
            //Log.d("Not an HTTP connection", ""); 
            	
                BMP_WEBCAM = BitmapFactory.decodeStream(in);
            try {
				in.close();
			} catch (IOException e) {
				Log.d("Web Cam: ", "Error closing input stream");
				e.printStackTrace();
			}
            
            runOnUiThread(new Runnable() {
            	public void run() {
            		IMG_WEBCAM.setImageBitmap(BMP_WEBCAM);
            	}
            });
			    	
		    return null;
		    
    	} // doInBackground()
    
    	protected void onPostExecute(Void result) {
    		if(PD_LOADING.isShowing()){
    				PD_LOADING.dismiss();
    		}
    	}
    
    } // imageRefresh, AsyncTask
    
}